/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package co.d3s.mca.project01.client;

import co.d3s.mca.project01.client.ui.DataTableModel;
import co.d3s.mca.project01.common.shittySerialization.ClientData;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.nio.file.Path;
import java.util.Arrays;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import static javax.swing.JFrame.EXIT_ON_CLOSE;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JScrollPane;
import javax.swing.JSpinner;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.SpinnerNumberModel;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;

/**
 *
 * @author 100574275
 */
public class ClientForm extends JFrame {
    private int newRows;
    
    private JTextField hostField;
    private JSpinner portField;
    private JButton toggleActiveButton;
    private JTable dataList;
    private JButton dataAddButton;
    private JButton dataDelButton;
    private JButton dataRefreshButton;
    private JButton dataUpdateButton;
    private JList<String> fileList;
    
    private JTextField debugField;
    
    private boolean active;
    private ClientThread clientThread;
    
    public ClientForm() {
        newRows = 0;
        setup();
    }
    public void setup() {
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException ex) {
            Logger.getLogger(ClientForm.class.getName()).log(Level.SEVERE, null, ex);
        }
        active = false;
        
        this.setSize(400, 300);
        this.setTitle("Client!");
        this.setDefaultCloseOperation(EXIT_ON_CLOSE);
        this.setLayout(new BorderLayout());
        
                
        JPanel centerPanel = new JPanel(new GridLayout(2,1));
        this.add(centerPanel, BorderLayout.CENTER);
        
        JPanel dataPanel = new JPanel(new BorderLayout());
        JScrollPane dataScrollPane = new JScrollPane();
        dataList = new JTable(new DataTableModel(this));
        dataList.setAutoCreateRowSorter(true);
        dataList.setFillsViewportHeight(true);
        dataScrollPane.setViewportView(dataList);
        dataPanel.add(dataScrollPane, BorderLayout.CENTER);
        
        JPanel dataControlPane = new JPanel(new GridLayout(1,4));
        
        dataAddButton = (JButton)dataControlPane.add(new JButton("Add Row"));
        dataAddButton.setEnabled(false);
        dataAddButton.addActionListener((ActionEvent e) -> {
            ClientData newClient = new ClientData(0 - ++newRows, "", "", "", "", "","", "", 0, 0, 0);
            ((DataTableModel)dataList.getModel()).addRow(newClient, true);
            dataUpdateButton.setEnabled(true);
        });
        dataDelButton = (JButton)dataControlPane.add(new JButton("Delete Row"));
        dataDelButton.setEnabled(false);
        dataDelButton.addActionListener((ActionEvent e) -> {
           //Need to remove from highest index to lowest index so indexes don't change.
           int[] indexes = dataList.getSelectedRows();
           Arrays.sort(indexes);
           for (int i = indexes.length - 1; i >= 0; i--) {
               ((DataTableModel)dataList.getModel()).delRow(indexes[i]);
           }
           dataUpdateButton.setEnabled(true);
        });
        dataRefreshButton = (JButton)dataControlPane.add(new JButton("Retrieve from Server"));
        dataRefreshButton.setEnabled(false);
        dataRefreshButton.addActionListener((ActionEvent e) -> {
            try {
                //Nuke the old entries, prepare for the new.
                ((DataTableModel)dataList.getModel()).clearRows();
                clientThread.RequestData();
            } catch (IOException ex) {
                Logger.getLogger(ClientForm.class.getName()).log(Level.SEVERE, null, ex);
            }
        });
        dataUpdateButton = (JButton)dataControlPane.add(new JButton("Send to Server"));
        dataUpdateButton.addActionListener((ActionEvent e) -> {
            //dataList.rowsChanged;
            ((DataTableModel)dataList.getModel()).rowsChanged.forEach((key, value) -> {
                //True means changed, False means not changed.
                if (value) {
                    ClientData row = ((DataTableModel)dataList.getModel()).getRow(key);
                    if (row != null) {
                        //Changed or new.
                        clientThread.UpdateData(row);
                    } else {
                        //Deleted.
                        clientThread.DeleteData(key.intValue());
                    }
                }
            });
           //clientThread.SendData() 
        });
        dataUpdateButton.setEnabled(false);
        
        dataPanel.add(dataControlPane, BorderLayout.SOUTH);
        
        centerPanel.add(dataPanel);
        
        JScrollPane folderScrollPane = new JScrollPane();
        fileList = new JList<>();
        fileList.setVisible(true);
        fileList.setEnabled(false);
        fileList.addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent evt) {
                System.out.println("Testing");
                if (evt.getClickCount() >= 2) {
                    int index = fileList.locationToIndex(evt.getPoint());
                    String file = fileList.getModel().getElementAt(index);
                    System.out.println(file);
                    try {
                        clientThread.RequestFile(file);
                    } catch (IOException ex) {
                        Logger.getLogger(ClientForm.class.getName()).log(Level.SEVERE, null, ex);
                    }
                }
            }
        });
        folderScrollPane.setViewportView(fileList);
        centerPanel.add(folderScrollPane);
        
        JPanel bottomPanel = new JPanel(new BorderLayout());
        bottomPanel.setVisible(true);
        this.add(bottomPanel, BorderLayout.SOUTH);
        
        JPanel connectionPanel = new JPanel(new BorderLayout());
        connectionPanel.setVisible(true);
        bottomPanel.add(connectionPanel, BorderLayout.CENTER);
        
        hostField = new JTextField("localhost");
        //hostField.setBounds(10, this.getHeight() - 10 - 60, 100, 30);
        hostField.setVisible(true);
        connectionPanel.add(hostField, BorderLayout.CENTER);
        
        SpinnerNumberModel portModel = new SpinnerNumberModel(25565, 1025, 65535, 1);
        portField = new JSpinner(portModel);
        //portField.setBounds(110, this.getHeight() - 10 - 60, 60, 30);
        portField.setVisible(true);
        connectionPanel.add(portField, BorderLayout.EAST);
        
        toggleActiveButton = new JButton("Connect");
        toggleActiveButton.setVisible(true);
        toggleActiveButton.addActionListener((ActionEvent e) -> {
            setActive(!active);
        });
        bottomPanel.add(toggleActiveButton, BorderLayout.EAST);
        
        debugField = new JTextField();
        debugField.setVisible(true);
        debugField.addActionListener((ActionEvent e) -> {
           clientThread.SendDebugMessage(debugField.getText());
        });
        this.add(debugField, BorderLayout.NORTH);
        
        this.setVisible(true);
    }
    private void setActive(boolean active) {
        if (this.active == active) {
            return; //We don't need to do any logic if its not actually different.
        }
        this.active = active;
                    
        hostField.setEnabled(!active);
        portField.setEnabled(!active);
            
        toggleActiveButton.setText(active ? "Disconnect" : "Connect");
        
        if (active) {
            clientThread = new ClientThread(hostField.getText(), (int)portField.getValue(), this);
            clientThread.start();
            System.out.println("Testing 123");
        } else {
            fileList.setEnabled(false);
            fileList.setListData(new String[]{});
            dataRefreshButton.setEnabled(false);
            dataAddButton.setEnabled(false);
            dataDelButton.setEnabled(false);
            dataList.setEnabled(false);
            dataUpdateButton.setEnabled(false);
            ((DataTableModel)dataList.getModel()).clearRows();
            try {
                clientThread.close(); //Hopefully kills everything
            } catch (IOException ex) {
                Logger.getLogger(ClientForm.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }
    public void loginResponse(byte response, String reason) {
        System.out.println(response);
        System.out.println(reason);
        switch(response) {
            case 00: //Valid
                //TODO: Unlock GUI when we receive this.
                clientThread.RequestFileList();
                break;
            case 01: //Invalid Username or Password
                JOptionPane.showMessageDialog(JOptionPane.getRootFrame(), reason,"Login Error", JOptionPane.ERROR_MESSAGE);
                loginPrompt();
                break;
        }
    }
    public void loginPrompt() {
        //TODO: Lock GUI we were told to login!
        JPanel panel = new JPanel(new GridLayout(2,2));
        JTextField userField = new JTextField();
        panel.add(new JLabel("Username: "));
        panel.add(userField);
        JPasswordField passField = new JPasswordField();
        panel.add(new JLabel("Password: "));
        panel.add(passField);
        int result = JOptionPane.showConfirmDialog(null, panel, 
               "Please Enter your username and password", JOptionPane.OK_CANCEL_OPTION);
      if (result == JOptionPane.OK_OPTION) {
         System.out.println("username: " + userField.getText());
         System.out.println("password: " + passField.getText());
         clientThread.SendLoginRequest(userField.getText(), passField.getText());
      }
    }
    public void fileList(String[] files) {
        System.out.println("Received file list");
        fileList.setListData(files);
        fileList.setEnabled(true);
        dataRefreshButton.setEnabled(true);
    }

    void FileTransfer(String fileName, byte[] fileData) throws IOException {
        System.out.println("Received file transfer for " + fileName);
        JFileChooser chooser = new JFileChooser(); 
        chooser.setCurrentDirectory(new java.io.File("."));
        chooser.setDialogTitle("Select Folder");
        chooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
        if (chooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
            String name = chooser.getSelectedFile().getAbsolutePath();
            FileOutputStream writer = new FileOutputStream(name);
            writer.write(fileData);
            writer.close();
        }
    }
    void DataObject(ClientData data) {
        System.out.println("Received a ClientData, clientID is " + data.clientID);
        ((DataTableModel)dataList.getModel()).addRow(data, false);
        dataAddButton.setEnabled(true);
        dataDelButton.setEnabled(true);
    }

    public void cellChanged(int rowIndex, int columnIndex) {
        dataUpdateButton.setEnabled(true);
    }
}
