/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package co.d3s.mca.project01.client.ui;

import co.d3s.mca.project01.client.ClientForm;
import co.d3s.mca.project01.common.shittySerialization.ClientData;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author 100574275
 */
public class DataTableModel extends AbstractTableModel {
    private ClientForm form;
    
    
    private String[] columnNames = {
        "clientID", "firstName", "lastName", "staffNumber", "mobilePhoneNumber", "MACaddress",
        "OSversion", "OSname", "maxMemory", "allocatedMemory", "freeMemory"
    };
    private Class[] columnTypes = {
        Integer.class, String.class, String.class, String.class, String.class, String.class,
        String.class, String.class, Integer.class, Integer.class, Integer.class
    };
    public HashMap<Integer,Boolean> rowsChanged;
    private HashMap<Integer,Integer> rowToClientID;
    public ArrayList<Integer> rowsDeleted;
    
    private ArrayList<ClientData> data;
    
    public DataTableModel(ClientForm form) {
        this.form = form;
        data = new ArrayList<>();
        rowsChanged = new HashMap<>();
        rowsDeleted = new ArrayList<Integer>();
        rowToClientID = new HashMap<>();
    }
    
    @Override
    public int getRowCount() {
        return data.size();
    }
    @Override
    public int getColumnCount() {
        return 11;
    }
    @Override
    public String getColumnName(int col) {
        return columnNames[col];
    }
    @Override
    public Class getColumnClass(int col) {
        return columnTypes[col];
    }
    /*
    * Don't need to implement this method unless your table's
    * editable.
    */
    @Override
    public boolean isCellEditable(int row, int col) {
        //Note that the clientID is constant,
        //no matter where the cell appears onscreen.
        if (col > 0) {
            return true;
        }
        return false;
    }
    @Override
    public void setValueAt(Object value, int rowIndex, int columnIndex) {
        try {
            ClientData.class.getField(columnNames[columnIndex]).set(data.get(rowIndex), value);
            rowsChanged.put(data.get(rowIndex).clientID, true);
            fireTableCellUpdated(rowIndex, columnIndex);
            form.cellChanged(rowIndex, columnIndex);
        } catch (NoSuchFieldException ex) {
            Logger.getLogger(DataTableModel.class.getName()).log(Level.SEVERE, null, ex);
        } catch (SecurityException ex) {
            Logger.getLogger(DataTableModel.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IllegalArgumentException ex) {
            Logger.getLogger(DataTableModel.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            Logger.getLogger(DataTableModel.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        try {
            return ClientData.class.getField(columnNames[columnIndex]).get(data.get(rowIndex));
        } catch (NoSuchFieldException ex) {
            Logger.getLogger(DataTableModel.class.getName()).log(Level.SEVERE, null, ex);
        } catch (SecurityException ex) {
            Logger.getLogger(DataTableModel.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IllegalArgumentException ex) {
            Logger.getLogger(DataTableModel.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            Logger.getLogger(DataTableModel.class.getName()).log(Level.SEVERE, null, ex);
        }
        return null;
    }
    public void clearRows() {
        data.clear();
    }
    public void addRow(ClientData clientData, boolean manual) {
        rowToClientID.put(clientData.clientID, data.size());
        rowsChanged.put(clientData.clientID, manual);
        data.add(clientData);
        fireTableRowsInserted(data.size() - 1, data.size() - 1);
    }
    public ClientData getRow(int clientID) {
        Integer id = rowToClientID.get(clientID);
        if (id != null)
            return data.get(id);
        return null;
    }
    public void delRow(int index) {
        if (data.get(index).clientID > -1) {
            rowsDeleted.add(data.get(index).clientID);
            rowsChanged.put(data.get(index).clientID, true);
        } else {
            rowsChanged.put(data.get(index).clientID, false);
        }
        //Remove the mapping, no one cares anymore.
        rowToClientID.remove(data.get(index).clientID);
        data.remove(index);
        fireTableRowsDeleted(index, index);
    }
    
}
