/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package co.d3s.mca.project01.server;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.sql.Connection;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.SpinnerNumberModel;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;

/**
 *
 * @author 100574275
 */
public class ServerForm extends JFrame {
    private ServerThread serverThread;
    
    private JTextField hostField;
    private JSpinner portField;
    private JButton toggleActiveButton;
    
    private JButton browseButton;
    private JTextField folderField;
    
    private Connection con;
    
    private boolean active;
    
    public ServerForm(Connection con) {
        this.con = con;
        setup();
    }
    public void setup() {
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(ServerForm.class.getName()).log(Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            Logger.getLogger(ServerForm.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            Logger.getLogger(ServerForm.class.getName()).log(Level.SEVERE, null, ex);
        } catch (UnsupportedLookAndFeelException ex) {
            Logger.getLogger(ServerForm.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        
        active = false;
        
        this.setSize(400, 300);
        this.setTitle("Server!");
        this.setDefaultCloseOperation(EXIT_ON_CLOSE);
        this.setLayout(new BorderLayout());
        
        JPanel bottomPanel = new JPanel(new BorderLayout());
        bottomPanel.setVisible(true);
        this.add(bottomPanel, BorderLayout.SOUTH);
        
        JPanel connectionPanel = new JPanel(new BorderLayout());
        connectionPanel.setVisible(true);
        bottomPanel.add(connectionPanel, BorderLayout.CENTER);
        
        JPanel folderPanel = new JPanel(new BorderLayout());
        folderPanel.setVisible(true);
        connectionPanel.add(folderPanel, BorderLayout.NORTH);
        
        folderField = new JTextField(new java.io.File("").getAbsolutePath());
        folderField.setVisible(true);
        folderPanel.add(folderField, BorderLayout.CENTER);
        
        browseButton = new JButton("Browse");
        browseButton.setVisible(true);
        browseButton.addActionListener((ActionEvent e) -> {
            JFileChooser chooser = new JFileChooser(); 
            chooser.setCurrentDirectory(new java.io.File("."));
            chooser.setDialogTitle("Select Folder");
            chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
            //
            // disable the "All files" option.
            //
            chooser.setAcceptAllFileFilterUsed(false);
            //    
            if (chooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
                folderField.setText(chooser.getSelectedFile().getAbsolutePath());
            }
            else {
              System.out.println("No Selection ");
            }
        });
        folderPanel.add(browseButton, BorderLayout.EAST);
        
        hostField = new JTextField("localhost");
        //hostField.setBounds(10, this.getHeight() - 10 - 60, 100, 30);
        hostField.setVisible(true);
        connectionPanel.add(hostField, BorderLayout.CENTER);
        
        SpinnerNumberModel portModel = new SpinnerNumberModel(25565, 1025, 65535, 1);
        portField = new JSpinner(portModel);
        //portField.setBounds(110, this.getHeight() - 10 - 60, 60, 30);
        portField.setVisible(true);
        connectionPanel.add(portField, BorderLayout.EAST);
        
        toggleActiveButton = new JButton("Start");
        toggleActiveButton.setVisible(true);
        toggleActiveButton.addActionListener((ActionEvent e) -> {
            setActive(!active);
        });
        bottomPanel.add(toggleActiveButton, BorderLayout.EAST);

        this.setVisible(true);
    }
    
    private void setActive(boolean active) {
        if (this.active == active) {
            return; //We don't need to do any logic if its not actually different.
        }
        this.active = active;
                    
        hostField.setEnabled(!active);
        portField.setEnabled(!active);
        
        folderField.setEnabled(!active);
        browseButton.setEnabled(!active);
            
        toggleActiveButton.setText(active ? "Stop" : "Start");
        Path path;
        try {
            path = Paths.get(folderField.getText());
        } catch (java.nio.file.InvalidPathException e) {
            path = Paths.get("");
        }
        System.out.println(path.toAbsolutePath());
        if (active) {
            serverThread = new ServerThread(hostField.getText(), (int)portField.getValue(), path, con);
            serverThread.start();
        } else {
            try {
                serverThread.close(); //Hopefully kills everything
            } catch (IOException ex) {
                Logger.getLogger(ServerForm.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }
}
