/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package co.d3s.mca.project01.server;

import java.io.Closeable;
import java.io.IOException;
import java.nio.file.Path;
import java.net.InetAddress;
import java.net.ServerSocket;
import java.net.Socket;
import java.sql.Connection;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author 100574275
 */
public class ServerThread extends Thread implements Closeable {
    private ServerSocket socket;
    private String hostname;
    private int port;
    
    private volatile boolean running;
    
    private Path path;
    private Connection con;
    
    public ServerThread(String hostname, int port, Path path, Connection con) {
        super();
        this.hostname = hostname;
        this.port = port;
        this.running = false;
        this.path = path;
        this.con = con;
    }
    @Override
    public void run() {
        try {
            socket = new ServerSocket(port,50, InetAddress.getByName(hostname));
            running = true;
        } catch (IOException ex) {
            Logger.getLogger(ServerThread.class.getName()).log(Level.SEVERE, null, ex);
            return;
        }
        while(running) {
            Socket clientSocket = null;
            try {
                clientSocket = socket.accept();
                clientSocket.setSoTimeout(30*1000); //After 30 seconds of no traffic, kill the socket.
            } catch (IOException ex) {
                if (!running) {
                    Logger.getLogger(ServerThread.class.getName()).log(Level.INFO, "Server has turned off.");
                    return;
                }
                Logger.getLogger(ServerThread.class.getName()).log(Level.SEVERE, "socket.accept() exception during running server.", ex);
                ex.printStackTrace();
            }
            //If we got here, the socket was made successfully.
            new ServerThreadWorker(clientSocket, path, con).start();
        }
    }

    @Override
    public void close() throws IOException {
        if (socket != null) {
            socket.close();
            running = false;
        }
    }
}
