/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package co.d3s.mca.project01.server;

import co.d3s.mca.project01.common.shittySerialization.ClientData;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.regex.Pattern;

/**
 *
 * @author 100574275
 */
public class ServerThreadWorker extends Thread {
    private Socket socket;
    private DataInputStream inStream;
    private DataOutputStream outStream;
    
    private volatile boolean loggedIn;
    
    private Connection con;
    private Path path;
    
    public ServerThreadWorker(Socket socket, Path path, Connection con) {
        this.socket = socket;
        this.path = path;
        this.con = con;
    }
    public void run() {
        System.out.println("New connection!");
        loggedIn = false;
        try {
            inStream = new DataInputStream(socket.getInputStream());
            outStream = new DataOutputStream(socket.getOutputStream());
            SendLoginRequest();
            while(!socket.isClosed()) {
                int packet = inStream.read();
                switch(packet) {
                    case ServerPacketEnum.LOGIN:
                        System.out.println("Hey we received a login packet");
                        String username = ReadString();
                        String password = ReadString();
                        System.out.println("[LOGIN] Username = \"" + username + "\", Password = \"" + password + "\"");
                        String query = "SELECT NAME, PASS FROM `users` WHERE NAME = '"+username+"' AND PASS = '"+password+"'";
                        Statement statement = con.createStatement();
                        //statement.setString(2, password);
                        ResultSet result = statement.executeQuery(query);
                        if (result.next()) {
                            String name = result.getString("name");
                            String pass = result.getString("pass");
                            loggedIn = true;
                            SendLoginResponse((byte)0, "OK");
                            System.out.println("[DB] " + name + ", " + pass);
                        } else {
                            //TODO: Put this in future log file.
                            SendLoginResponse((byte)1, "Username or Password is Incorrect.");
                        }
                        break;
                    case ServerPacketEnum.FILE_TRANSFER:
                        String fileName = ReadString();
                        int len = inStream.readInt();
                        int currentLength = 0;
                        byte[] data = new byte[len];
                        do {
                        currentLength += inStream.read(data, currentLength, len - currentLength);
                        } while (currentLength < len);
                        break;
                        //TODO: use fileName and data, and apply to disk or something.
                    case ServerPacketEnum.FILE_LIST:
                        //TODO: Insert logic for spitting file list back.
                        System.out.println("===" + this.path + "===");
                        ArrayList<String> files = new ArrayList<>();
                        
                        Files.walk(this.path).forEach(filePath -> {
                            if (Files.isRegularFile(filePath)) {
                                files.add(filePath.toString().substring(this.path.toString().length()).replaceAll(Pattern.quote("\\"), "/"));
                            }
                        });
                        outStream.writeByte(ServerPacketEnum.FILE_LIST);
                        outStream.writeShort(files.size());
                        for (String file : files) {
                            WriteString(file);
                        }
                        outStream.flush();
                        break;
                    case ServerPacketEnum.FILE_REQUEST:
                        String file = ReadString();
                        System.out.println("1: " + file);
                        String file2 = this.path + file;
                        System.out.println("2: " + file2);
                        /*if (System.getProperty("os.name").toLowerCase().contains("win")) {
                            file2 = file2.replaceAll("/", Pattern.quote("\\"));
                        }*/
                        System.out.println("3: " + file2);
                        File test = new File(file2);
                        if (test.canRead()) {
                            FileInputStream ifs = new FileInputStream(test);
                            byte[] fileData = new byte[(int)test.length()];
                            int currentFileLength = 0;
                            do {
                                currentFileLength += ifs.read(fileData, currentFileLength, fileData.length - currentFileLength);
                            } while (currentFileLength < fileData.length);
                            outStream.write(ServerPacketEnum.FILE_TRANSFER);
                            WriteString(file);
                            outStream.writeInt(fileData.length);
                            outStream.write(fileData);
                            outStream.flush();
                        } else {
                            System.out.println("Send help...");
                            System.out.println(file2);
                        }
                        break;
                    case ServerPacketEnum.KEEP_ALIVE:
                        System.out.println("Received a keep alive packet, sending one back.");
                        outStream.writeByte(ServerPacketEnum.KEEP_ALIVE);
                        break;
                    case ServerPacketEnum.DATA_REQUEST:
                        //TODO: Access DB.
                        String dataQuery = "SELECT * FROM `ClientData`";
                        Statement dataStatement = con.createStatement();
                        ResultSet dataResult = dataStatement.executeQuery(dataQuery);
                        while (dataResult.next()) {
                            ClientData testData = new ClientData(dataResult.getInt(1), dataResult.getString(2),dataResult.getString(3),dataResult.getString(4),dataResult.getString(5),dataResult.getString(6),dataResult.getString(7),dataResult.getString(8),dataResult.getLong(9),dataResult.getLong(10),dataResult.getLong(11));
                            ByteArrayOutputStream outByte = new ByteArrayOutputStream();
                            ObjectOutputStream outObject = new ObjectOutputStream(outByte);
                            outObject.writeObject(testData);
                            byte[] bytes = outByte.toByteArray();
                            outStream.write((byte)ServerPacketEnum.SHITTY_SERIALIZATION);
                            outStream.writeShort(bytes.length);
                            outStream.write(bytes);
                            outStream.flush();
                        }
                        break;
                    case ServerPacketEnum.DATA_UPDATE:
                        short datalen = inStream.readShort();
                        byte[] datadata = ReadByteArray(datalen);
                        System.out.println("Read everything from the wire");
                        ObjectInputStream newStream = new ObjectInputStream(new ByteArrayInputStream(datadata));
                        ClientData object = (ClientData) newStream.readObject();
                        if (object.clientID > -1) {
                            //Update
                        } else {
                            //New
                        }
                        System.out.println("Read the object and tried to cast it.");
                        break;
                    case ServerPacketEnum.DATA_DELETE:
                        int id = inStream.readInt();
                        break;
                    case ServerPacketEnum.DEBUG:
                        System.out.println("Hey we received a debug packet");
                        String string = ReadString();
                        System.out.println("[DEBUG] " + string);
                        break;
                }
            }
            /*//This is where we do stuff
            socket.getOutputStream().write((byte)'H');
            socket.getOutputStream().write((byte)'e');
            socket.getOutputStream().write((byte)'l');
            socket.getOutputStream().write((byte)'l');
            socket.getOutputStream().write((byte)'o');
            socket.getOutputStream().write((byte)' ');
            socket.getOutputStream().write((byte)'W');
            socket.getOutputStream().write((byte)'o');
            socket.getOutputStream().write((byte)'r');
            socket.getOutputStream().write((byte)'l');
            socket.getOutputStream().write((byte)'d');
            socket.getOutputStream().flush();
            socket.close(); */
        } catch (IOException ex) {
            Logger.getLogger(ServerThreadWorker.class.getName()).log(Level.SEVERE, "IOException catch", ex);
        } catch (Exception ex) {
            Logger.getLogger(ServerThreadWorker.class.getName()).log(Level.SEVERE, "Generic Exception catch", ex);
        }
    }
    public void SendLoginRequest() {
        //We might have asked them to log in again, mark them as logged out
        loggedIn = false;
        try {
            outStream.write(ServerPacketEnum.LOGIN);
            outStream.flush();
            System.out.println("Sent login");
        } catch (IOException ex) {
            Logger.getLogger(ServerThreadWorker.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    public void SendLoginResponse(byte type, String reason) {
        try {
            outStream.write(ServerPacketEnum.LOGIN_RESPONSE);
            outStream.writeByte(type);
            WriteString(reason);
            outStream.flush();
            System.out.println("Sent login response");
        } catch (IOException ex) {
            Logger.getLogger(ServerThreadWorker.class.getName()).log(Level.SEVERE, null, ex);
        }    
    }
    
    public void WriteString(String string) throws IOException {
        byte[] stringData = string.getBytes(StandardCharsets.UTF_8);
        outStream.writeShort(stringData.length);
        outStream.write(stringData, 0, stringData.length);
    }
    String ReadString() throws IOException, Exception {
        short length = inStream.readShort();
        if (length > -1) {
            int currentLength = 0;
            byte[] pendingString = new byte[length];
            do {
            currentLength += inStream.read(pendingString, currentLength, length - currentLength);
            } while (currentLength < length);
            String string = new String(pendingString, StandardCharsets.UTF_8);
            return string;
        } else {
            throw new Exception("WTF");
        }
    }
    byte[] ReadByteArray(int len) throws IOException {
        int currentLength = 0;
        //Make sure we read this entire byte array.
        byte[] data = new byte[len];
        do {
        currentLength += inStream.read(data, currentLength, len - currentLength);
        } while (currentLength < len);
        return data;
    }
}
